#include <iostream>;
#include <stdlib.h>
#include <ctime>
#include <string>
#include <fstream>
#include <vector>
#include <algorithm>
#include <iterator>
using namespace std;

void createData1() {
	ofstream file("MyFile.txt");
	srand(time(nullptr));          
	if (!file.is_open()) cout << "Error";
	else {
		for (int i = 0; i < 100; i++) {
			int a = rand() % 101 - 50;
			file << a << " ";
		}
	}
	file.close();
}

void createData2() {
	vector<int> vec(100);
	ofstream file("MyFile.txt");
	srand(time(nullptr));     
	if (!file.is_open()) cout << "Error";
	else {
		generate(vec.begin(), vec.end(), []() {return rand() % 101 - 50; });
		copy(vec.begin(), vec.end(), ostream_iterator<int>(file, " "));
	}
	file.close();
}

template <typename T>
void loadData1(T& container) {
	ifstream file("MyFile.txt");
	if (!file.is_open()) cout << "Error";
	else {
		for (int i = 0; i < 100; i++) {
			int a;
			file >> a;
			container.push_back(a);
		}
	}
	file.close();
}

template <typename T>
void loadData2(T& container) {
	ifstream file("MyFile.txt");
	if (!file.is_open()) cout << "Error";
	else {
		copy(istream_iterator<int>(file), istream_iterator<int>(), back_inserter(container));
	}
	file.close();
}

template<typename T>
void modify1(T& container) {
	auto first_negative = *find_if(container.begin(), container.end(), [](auto s) {return (s < 0); });
	auto elem_50 = container.at(49);
	int sum = 0;
	for (auto a = container.begin(); a < container.end(); a++) {
		if ((first_negative + elem_50) != 0) *a = *a / ((first_negative + elem_50) / 2);
		else *a = 0;
		sum += *a;
	}
	container.push_back(abs(sum));
	container.push_back(abs(sum/100));
}

template<typename T>
void modify2(T Iter_begin, T Iter_end) {
	auto first_negative = *find_if(Iter_begin, Iter_end, [](auto s) {return (s < 0); });
	auto elem_50 = *(Iter_begin + 49);
	for_each(Iter_begin, Iter_end, [first_negative, elem_50](auto& s) {if ((first_negative + elem_50) != 0) s = s / ((first_negative + elem_50) / 2); else s = 0; });
}

template<typename T>
void modify3(T& container) {
	auto first_negative = *find_if(container.begin(), container.end(), [](auto s) {return (s < 0); });
	auto elem_50 = container.at(49);
	for_each(container.begin(), container.end(), [first_negative, elem_50](auto& s) {if ((first_negative + elem_50) != 0) s = s / ((first_negative + elem_50) / 2);  else  s = 0;  });
}

template<typename T>
void modify4(T& container) {
	auto first_negative = *find_if(container.begin(), container.end(), [](auto& s) {return (s < 0); });
	auto elem_50 = container.at(49);
	transform(container.begin(), container.end(), container.begin(), [first_negative, elem_50](auto s) {if ((first_negative + elem_50) != 0) return int(s / ((first_negative + elem_50) / 2)); else return 0; });
}

template<typename T>
void outputResult1(T& container) {
	ofstream file("MyFile.txt");
	if (!file.is_open()) cout << "Error";
	else {
		for (auto a = container.begin(); a < container.end(); a++) {
			file << *a << " ";
		}
	}
	file.close();
}

template<typename T>
void outputResult2(T& container) {
	ofstream file("MyFile.txt");
	if (!file.is_open()) cout << "Error";
	else {
		copy(container.begin(), container.end(), ostream_iterator<int>(file, " "));
	}
	file.close();
}

int main() {
	bool continuar = true;
	int function_number;
	vector<int> vec;
	ifstream file;
	while (continuar) {
		cout << "Select the function:" << endl
			<< "    1)createData1" << endl
			<< "    2)createData2" << endl
			<< "    3)loadData1" << endl
			<< "    4)loadData2" << endl
			<< "    5)modify1" << endl
			<< "    6)modify2" << endl
			<< "    7)modify3" << endl
			<< "    8)modify4" << endl
			<< "    9)outputResult1" << endl
			<< "    10)outputResult2" << endl
			<< "To exit press 0" << endl << endl;
		cin >> function_number;
		switch (function_number)
		{
		case 1:
			createData1();
			file.open("MyFile.txt");
			cout << "File output:" << endl;
			if (!file.is_open()) cout << "Error";
			else {
				for_each(istream_iterator<int>(file), istream_iterator<int>(), [](auto& s) {cout << s << " "; });
			}
			cout << endl << endl;
			file.close();
			break;
		case 2:
			createData2();
			file.open("MyFile.txt");
			cout << "File output:" << endl;
			if (!file.is_open()) cout << "Error";
			else {
				for_each(istream_iterator<int>(file), istream_iterator<int>(), [](auto& s) {cout << s << " "; });
			}
			cout << endl << endl;
			file.close();
			break;
		case 3:
			loadData1(vec);
			cout << "Container output:" << endl;
			for_each(vec.begin(), vec.end(), [](auto s) {cout << s << " "; });
			cout << endl << endl;
			break;
		case 4:
			loadData2(vec);
			cout << "Container output:" << endl;
			for_each(vec.begin(), vec.end(), [](auto s) {cout << s << " "; });
			cout << endl << endl;
			break;
		case 5:
			modify1(vec);
			cout << "Container output:" << endl;
			for_each(vec.begin(), vec.end(), [](auto s) {cout << s << " "; });
			cout << endl << endl;
			break;
		case 6:
			modify2(vec.begin(), vec.end());
			cout << "Container output:" << endl;
			for_each(vec.begin(), vec.end(), [](auto s) {cout << s << " "; });
			cout << endl << endl;
			break;
		case 7:
			modify3(vec);
			cout << "Container output:" << endl;
			for_each(vec.begin(), vec.end(), [](auto s) {cout << s << " "; });
			cout << endl << endl;
			break;
		case 8:
			modify4(vec);
			cout << "Container output:" << endl;
			for_each(vec.begin(), vec.end(), [](auto s) {cout << s << " "; });
			cout << endl << endl;
			break;
		case 9:
			outputResult1(vec);
			file.open("MyFile.txt");
			cout << "File output:" << endl;
			if (!file.is_open()) cout << "Error";
			else {
				for_each(istream_iterator<int>(file), istream_iterator<int>(), [](auto& s) {cout << s << " "; });
			}
			cout << endl << endl;
			file.close();
			break;
		case 10:
			outputResult2(vec);
			file.open("MyFile.txt");
			cout << "File output:" << endl;
			if (!file.is_open()) cout << "Error";
			else {
				for_each(istream_iterator<int>(file), istream_iterator<int>(), [](auto& s) {cout << s << " "; });
			}
			cout << endl << endl;
			file.close();
			break;
		default:
			continuar = false;
			break;
		}
	}
	file.close();
	return 0;
}
