#include "Function.h"

void Primary_input(const std::string& filename) {
	std::ofstream file(filename + ".bin", std::ios::out | std::ios::binary | std::ios::app);
	if (!file.is_open()) {
		std::cout << "Error: the file did not open!" << std::endl << std::endl;
	}
	else {
		bool Indicator = true;
		Product elem;
		while (Indicator) {
			elem.NewProduct();

			file.write(reinterpret_cast<char*>(&elem), sizeof(Product)); 

			std::cout << std::endl << "Add another item entry to the file?" << std::endl << "\t1 - yes" << std::endl << "\t0 - no" << std::endl;
			std::cin >> Indicator;
			std::cout << std::endl;
		}
	}
	file.close();
}

void Add_to_file(const std::string& filename) {
	Primary_input(filename);
}

void Delete_an_record(const std::string& filename) {
	std::ifstream file(filename + ".bin", std::ios::binary);
	if (!file) {
		std::cout << "Error: the file did not open!" << std::endl << std::endl;
	}
	else {
		int num;
		std::cout << "Enter the number of the record to delete:";
		std::cin >> num;
		List_Product records;

		records.Input(file);


		file.close();
		records.Output_map_Product().erase(num);
		std::ofstream file(filename + ".bin", std::ios::binary);
		records.Output(file);
		std::cout << std::endl;
	}
	file.close();
}

void Replace_record(const std::string& filename) {
	std::ifstream file(filename + ".bin", std::ios::binary);
	if (!file) {
		std::cout << "Error: the file did not open!" << std::endl << std::endl;
	}
	else {
		int num;
		std::cout << "Enter the record number to replace:";
		std::cin >> num;
		List_Product records;

		records.Input(file);
		file.close();
		Product record; 
		record.NewProduct();
        // НЕ НАДО ВОЗВРАЩАТЬ ССЫЛКУ ИЗ ФУНКЦИИ Output_map_Product -
        // ЭТО НАРУШАЕТ СОКРЫТИЕ ДАННЫХ В КЛАССЕ,
        // ВМЕСТО ЭТОГО НАДО ПЕРЕГРУЗИТЬ ОПЕРАТОР [] ДЛЯ КЛАССА List_Product,
        // ИЛИ НАПИСАТЬ ФУНКЦИЮ Replace(int), КОТОРАЯ БУДЕТ ДЕЛАТЬ ЗАМЕНУ ПРОДУКТА
		records.replace(num,record);
		std::ofstream file(filename + ".bin", std::ios::binary);
		records.Output(file);
		std::cout << std::endl;
	}
	file.close();
}

void Search_for_records(const std::string& filename) {
	std::ifstream file(filename + ".bin", std::ios::binary);
	if (!file) {
		std::cout << "Error: the file did not open!" << std::endl << std::endl;
	}
	else {
		std::string Newfilename;
		std::cout << "Enter a file name to save the found records:";
		std::cin >> Newfilename;
		List_Product records;
		records.Input(file);
		file.close();
		std::cout << "Search by..." << std::endl
			<< "\t1 - warehouse number" << std::endl
			<< "\t2 - product code" << std::endl
			<< "\t3 - date of receipt" << std::endl
			<< "\t4 - shelf life" << std::endl;
		int switch_on;
		std::cin >> switch_on;
		switch (switch_on)
		{
		case 1:
			records = (records.Search_by_warehouse_number());
			break;
		case 2:
			records = (records.Search_by_product_code());
			break;
		case 3:
			records = (records.Search_by_date_of_receipt());
			break;
		case 4:
			records = (records.Search_by_shelf_life());
			break;
		default:
			break;
		}
		std::ofstream file(Newfilename + ".bin", std::ios::binary);

		records.Output(file); 
		std::cout << std::endl;
	}
	file.close();
}

void Convert_to_a_text_file(const std::string& filename) {
	std::ifstream file_bin(filename + ".bin", std::ios::binary);
	std::ofstream file_txt(filename + ".txt"); 
	if (!file_bin || !file_txt) {
		std::cout << "Error: the file did not open!" << std::endl << std::endl;
	}
	else {
		file_txt << std::setw(30) << std::left << "Warehouse number" << std::setw(30) << std::left << "Product code" << std::setw(30) << std::left << "Product name"
			<< std::setw(30) << std::left << "Date of receipt" << std::setw(30) << std::left << "Shelf life in days" << std::setw(30) << std::left << "Number of product units"
			<< std::setw(30) << std::left << "Unit price" << std::endl;
		List_Product records;
		records.Input(file_bin);
		int total_shelf_life = 0, total_quantity = 0, total__price = 0;
		for (const auto& elem : records.Output_map_Product()) {

			file_txt << std::setw(30) << std::left << elem.second.Output_number_warehouse() << std::setw(30) << std::left << elem.second.Output_code()
				<< std::setw(30) << std::left << elem.second.Output_name() << elem.second.Output_date()[0] << "."
				<< elem.second.Output_date()[1] << "." << std::setw(25) << std::left << elem.second.Output_date()[2] << std::setw(30) << std::left << elem.second.Output_shelf_life()
				<< std::setw(30) << std::left << elem.second.Output_quantity() << std::setw(30) << std::left << elem.second.Output_price() << std::endl;
			total_shelf_life += elem.second.Output_shelf_life();
			total_quantity += elem.second.Output_quantity();
			total__price += elem.second.Output_price();
		}
		file_txt << std::setw(120) << std::left << "General data:" << std::setw(30) << std::left << total_shelf_life << std::setw(30) << std::left
			<< total_quantity << std::setw(30) << std::left << total__price;
	}
	file_txt.close();
	file_bin.close();
	std::cout << std::endl;
}
