#include "Product.h"


void Product::NewProduct() {
	std::cout << "\tEnter the warehouse number:";
	std::cin >> number_warehouse;
	std::cout << "\tEnter the product code:";
	std::cin >> code;
	std::cout << "\tEnter the product name:";
	std::cin >> name;
	std::cout << "\tEnter the date of receipt to the warehouse:" << std::endl << "\t\tday:";
	std::cin >> date_day;
	std::cout << "\t\tmonth:";
	std::cin >> date_month;
	std::cout << "\t\tyear:";
	std::cin >> date_year;
	std::cout << "\tEnter the retention period in days:";
	std::cin >> shelf_life;
	std::cout << "\tEnter the number of units of the product:";
	std::cin >> quantity;
	std::cout << "\tEnter the unit price:";
	std::cin >> price;
}


int Product::date_in_days() const {
	return atoi(date_year) * 365 + atoi(date_month) * 30 + atoi(date_day);
}

int Product::Output_number_warehouse() const {
	return atoi(number_warehouse);
}
int Product::Output_code() const {
	return atoi(code);
}
std::vector<int> Product::Output_date() const {
	std::vector<int> date;
	date.push_back(atoi(date_day));
	date.push_back(atoi(date_month));
	date.push_back(atoi(date_year));
	return date;
}
int Product::Output_shelf_life() const {
	return atoi(shelf_life);
}

std::string Product::Output_name() const {
	return name;
}

int Product::Output_quantity() const {
	return atoi(quantity);
}

int Product::Output_price() const {
	return atoi(price);
}

Product::Product(const Product& elem) {
	strcpy_s(number_warehouse, elem.number_warehouse);
	strcpy_s(code, elem.code);
	strcpy_s(name, elem.name);
	strcpy_s(date_day, elem.date_day);
	strcpy_s(date_month, elem.date_month);
	strcpy_s(date_year, elem.date_year);
	strcpy_s(shelf_life, elem.shelf_life);
	strcpy_s(quantity, elem.quantity);
	strcpy_s(price, elem.price);
}

Product& Product::operator =(const Product& elem) {
	strcpy_s(number_warehouse, elem.number_warehouse);
	strcpy_s(code, elem.code);
	strcpy_s(name, elem.name);
	strcpy_s(date_day, elem.date_day);
	strcpy_s(date_month, elem.date_month);
	strcpy_s(date_year, elem.date_year);
	strcpy_s(shelf_life, elem.shelf_life);
	strcpy_s(quantity, elem.quantity);
	strcpy_s(price, elem.price);
	return *this;
}


Product& List_Product::operator[](size_t num) {
	return map_Product[num];
}



void List_Product::Input(std::ifstream& file) {
	Product elem;
    // ПОЧЕМУ ЧТЕНИЕ ИЗ ФАЙЛА ПРОИСХОДИТ В ОДИН И ТОТ ЖЕ ОБЪЕКТ?
    // КРОМЕ ТОГО ЭТОТ ОБЪЕКТ ЛОКАЛЬНЫЙ И РЕЗУЛЬТАТ НИКУДА НЕ ПЕРЕДАЁТСЯ
	/*while (file.read(reinterpret_cast<char*>(&elem), sizeof(Product))) { 
	}*/
	while (file.read(reinterpret_cast<char*>(&elem), sizeof(Product))) {
		map_Product[++size] = elem;
	}
}

void List_Product::Output(std::ofstream& file) {
	for_each(map_Product.begin(), map_Product.end(), [&](auto& elem) { 
		file.write(reinterpret_cast<char*>(&(elem.second)), sizeof(Product));
		});
}

std::map<size_t, Product>& List_Product::Output_map_Product() {
	return map_Product;
}

List_Product List_Product::Search_by_warehouse_number() {
	int number;
	std::cout << "Enter the warehouse number:";
	std::cin >> number;
	List_Product result;
	for (auto& i : map_Product) {
		if (i.second.Output_number_warehouse() == number) {

			result[++(result.size)] = i.second;
		}
	}
	return result;
}

List_Product List_Product::Search_by_product_code() {
	int code;
	std::cout << "Enter the product code:";
	std::cin >> code;
	List_Product result;


	for_each(map_Product.begin(), map_Product.end(), [&](const auto& elem) {
		if (elem.second.Output_code() == code) {
			result[++(result.size)] = elem.second;
		}
		});
	return result;
}

List_Product List_Product::Search_by_date_of_receipt() {
	int day, month, year;
	std::cout << "Enter the date:" << std::endl;
	std::cout << "\tday: ";
	std::cin >> day;
	std::cout << "\tmonth: ";
	std::cin >> month;
	std::cout << "\tyear: ";
	std::cin >> year;
	std::vector<int> date;
	List_Product result;
	for_each(map_Product.begin(), map_Product.end(), [&](const auto& elem) {
		date = elem.second.Output_date();
		if (date.at(0) == day && date.at(1) == month && date.at(2) == year) {
			result[++(result.size)] = elem.second;
		}
		});
	return result;
}

List_Product List_Product::Search_by_shelf_life() {

	bool overdue_or_no;
	int day, month, year, date_in_days;
	std::cout << "Find..." << std::endl
		<< "\t1 - expired products" << std::endl
		<< "\t0 - non-expired products" << std::endl;
	std::cin >> overdue_or_no;
	std::cout << "Enter today's date:" << std::endl;
	std::cout << "\tday: ";
	std::cin >> day;
	std::cout << "\tmonth: ";
	std::cin >> month;
	std::cout << "\tyear: ";
	std::cin >> year;
	date_in_days = year * 365 + month * 30 + day;
	List_Product result;
	if (overdue_or_no == 1) {
		for_each(map_Product.begin(), map_Product.end(), [&](const auto&elem) {
			if (elem.second.date_in_days() + elem.second.Output_shelf_life() <= date_in_days) {
				result[++(result.size)] = elem.second;
			}
			});
	}
	else {
		for_each(map_Product.begin(), map_Product.end(), [&](const auto&elem) {
			if (elem.second.date_in_days() + elem.second.Output_shelf_life() > date_in_days) {
				result[++(result.size)] = elem.second;
			}
			});
	}
	return result;
}

void List_Product::replace(int num, Product record) {
	map_Product[num] = record;
}
